//
//      BNsimulator.java
//
//      Modified by Y.Motomura(motomura@etl.go.jp)

import java.util.*;
import java.awt.*;
import java.net.URL;
import java.applet.Applet;

public class BNsimulator extends Applet implements TCPserver {
    final static int Default_PORT=6700; /* Base TCP/IP port No.(+NodeId) */
    Nodes nodes;

    BNsimulator(){}

    public void init() {

// Mem space Allocation
        nodes = new Nodes();
        new TCP(Default_PORT,this);  // This port is Main network I/F
    }

    public void quit(){
	System.exit(0);
    }	

// real process method service(input, output) used in TCP.class is defined here.

    public void service(String in, StringBuffer out){
	int i;
	StringTokenizer st;
	String word;
	Node n;
	int t;

	st = new StringTokenizer(in);
	if(st.hasMoreTokens()!=true) return;
	word = new String(st.nextToken());
System.out.println("Message = "+in);
	if("SET_STREAM_ID".equals(word)) return;
	if("new".equals(word)){
		if(st.hasMoreTokens()!=true) return; 
		word = new String(st.nextToken());
		if(st.hasMoreTokens()!=true) return; 
		t = Integer.parseInt(st.nextToken());
// Return node_ID(int) for Client side.
		out.append("node_ID ");
		out.append(Integer.toString(MakeNode(t, word)));
		return;
	}
	if("quit".equals(word)){
		quit();
        }
	if("setCondProb".equals(word)){
		nodes.setCondProb();
		return;
        }
        if("mkCondProb".equals(word)){
               nodes.mkCondProb();
               return;
        }

// Otherwise, command is sent for each Node.
	n = nodes.pickUpByName(word);
	if(n != null){
// If return value is required("get"), put Node name at first.
	   if("get".equals(st.nextToken())){
		 out.append(n.name);out.append(" ");
	   }
	   n.service(in.substring(word.length()),out);
	}
    }

    public int MakeNode(int type, String name){

	Node n = new Node(type, name);
        nodes.addElement(n);
	n.setNodes(nodes);
// set Node's attribute (size, name) before node.init();
	return(n.nodeId);
    }

    public static void main(String argv[]){
		BNsimulator bn = new BNsimulator();
		bn.init();
    }
}








