//
//
//  Node of Bayasian Network
//
//  Programmed by Y.Motomura(motomura@etl.go.jp)
//

import java.util.*;

public class Node implements TCPserver{
/* Class variable */
    public static int idCtr = 0;
    public final static int Default_PORT=6700; /* Base TCP/IP port No.(+NodeId) */
    public static boolean Node_TCP=false;     /* Listen for Each Node or not.*/
/* Status of Node */
    int nodeId;
    String name;
    public int Type;
    Nodes nodes;
    public Nodes  inNodes;   /* Parent nodes connected to input     */
    public boolean child_f = false;     /*  This node has parents or not*/
    public boolean evidence_f = false;  /*  This node is an evidence or not */

    public CondProb  cp;     /* Conditional Probability class(NN)   */
    Thread th;               /* for Montecarlo simulation           */
    public double outval[];  /* Output value of forward probability */


    Node(int t, String s) {
        nodeId = idCtr++;
        inNodes = new Nodes();
	name = new String(s);
	Type = t;
	outval = new double[Math.abs(Type)];
	if(Node_TCP){
		new TCP(nodeId+Default_PORT,this);
	}
    }

    public void getVal(){

//Now, implemented only for Feed forward Node.
	evidence_f = false;
	if(child_f){
System.out.println("Calc conditional Prob");
	  cp.getOut();
	}else{
//Here, setting prior is required, but do nothing yet.
System.out.println("not child node");
	}
	return;
    }

// Array version
    public void putVal(double d[]){
	int i,j;
	evidence_f = true;
	j = Math.abs(Type);
	for(i=0; i< j ; i++){
		outval[i] = d[i];
	}
	return;
    }

// Real value version
    public void putVal(int i, double x){

	evidence_f = true;
	outval[i] = x;
	return;
    }

    void setNodes(Nodes ns){
System.out.println("set Nodes");
	nodes = ns;
    }

    void mkCondProb(){

// get total size of parents vector.
	int insize = 0;
	if(inNodes == null) return;
        for (Enumeration e = inNodes.elements(); e.hasMoreElements();) {
       	    Node node = (Node)e.nextElement();
	    insize += Math.abs(node.Type);
	}
	if(insize == 0) return;
// make Conditional Probability(NN) by (this, InputSize, OutputSize)
	cp = new CondProb(this, insize, Math.abs(Type));
//  Load weight from file(name.net)
	cp.load();
    }

    void setCondProb(){

// get total size of parents vector.
        if(inNodes == null) return;
        if(cp == null) return;
//  Load weight from file(name.net)
        cp.load();
    }


// real process method service(input, output) used in TCP.class is defined here.
    public void service(String in, StringBuffer out){
	int i;
	StringTokenizer st;
	String word;
System.out.println("MSG@"+ name + "=" + in);
	st = new StringTokenizer(in);
	if(st.hasMoreTokens()!=true) return;
	word = new String(st.nextToken());
	if("forwardto".equals(word)){ 
	    if(st.hasMoreTokens()){ 
		word = new String(st.nextToken());
		Node n = nodes.pickUpByName(word);
		if(n == null){ System.exit(0); }
		n.inNodes.addElement(this);
		n.child_f = true;
	    }	
	    return;
	}
	if("backwardto".equals(word)){ 
	    if(st.hasMoreTokens()){ 
		word = new String(st.nextToken());
		Node n = nodes.pickUpByName(word);
		this.inNodes.addElement(n);
		this.child_f = true;
	    }	
	    return;
	}
	if("setCondProb".equals(word)){
		setCondProb();
		return;
	}
	if("set".equals(word)){ 
	    for(i=0; (i<outval.length)&&(st.hasMoreTokens()); i++){
		outval[i]=new Double(st.nextToken("( ),\n\t\r")).doubleValue();
	    }
	    return;
	}
  	if("get".equals(word)){ 
System.out.println("getVal!");
    	    getVal();
	    out.append("value ( ");
	    for(i=0; i<outval.length; i++){
		out.append(Double.toString(outval[i]));
		out.append(" ");
	    }
	    out.append(")");
	    return;	
	}
    }
}

